## cp2k 2.4.0

=== doc/Makefile ===
manual.pdf: manual.tex manual.bib
	pdflatex manual.tex
	bibtex manual
	makeindex manual
	pdflatex manual.tex
	pdflatex manual.tex
clean:
	rm manual.ind manual.ilg manual.blg manual.bbl \
           manual.toc manual.out manual.log manual.idx manual.aux

=== makefiles/Makefile ===
#
# make -j 16 sopt popt ssmp psmp
#
# will now perform a parallel build of 4 cp2k executables
#
.SUFFIXES: .F .dep .o .f90 .cu .c
SHELL = /bin/sh
#
# the home dir is taken from the current directory: you must cd to the makefiles
# directory before executing make.
# adding a symbolic link from the src directory to the Makefile in makefiles/ 
# also works fine
#
CP2KHOME := $(PWD)/..
ARCH     := $(shell $(CP2KHOME)/tools/get_arch_code)
LIB1      = cp2k_base_lib
LIB2      = cp2k_fft_lib
LIB3      = cp2k_dbcsr_lib
LIB4      = cp2k_ma_lib
LIB5      = cp2k_elpa_lib
LIBCP2K   = cp2k_lib

export VERSION=sopt
export WHAT   =_progr

### Dependent variables ###

ARCHDIR              = $(CP2KHOME)/arch
DOCDIR               = $(CP2KHOME)/doc
MAINEXEDIR           = $(CP2KHOME)/exe
MAINLIBDIR           = $(CP2KHOME)/lib
MAINOBJDIR           = $(CP2KHOME)/obj
PRETTYOBJDIR         = $(CP2KHOME)/obj/prettified
TOOLDIR              = $(OBJDIR)/tools
TOOLSRC              = $(CP2KHOME)/tools
SRCDIR               = $(CP2KHOME)/src
SRCDIRS              = $(SRCDIR):$(SRCDIR)/lib:$(SRCDIR)/arch_lib:$(SRCDIR)/dbcsr_lib:$(SRCDIR)/fft_lib:$(SRCDIR)/elpa_lib:$(TOOLSRC)/metadyn:$(CP2KHOME)/cuda_tools:$(CP2KHOME)/machine
MAKEFILE             = $(CP2KHOME)/makefiles/Makefile
MACHINEDEFS          = $(ARCHDIR)/$(ARCH).$(VERSION)
PROG                 = $(EXEDIR)/cp2k.$(VERSION)
CP2KSHELL            = $(EXEDIR)/cp2k_shell.$(VERSION)
FES                  = $(EXEDIR)/fes.$(VERSION)
EXEDIR               = $(MAINEXEDIR)/$(ARCH)
LIBDIR               = $(MAINLIBDIR)/$(ARCH)
OBJDIR               = $(MAINOBJDIR)/$(ARCH)
OBJECTDEFS           = $(SRCDIR)/OBJECTDEFS
LIB1_OBJECTDEFS      = $(SRCDIR)/lib/OBJECTDEFS
LIB2_OBJECTDEFS      = $(SRCDIR)/dbcsr_lib/OBJECTDEFS
LIB3_OBJECTDEFS      = $(SRCDIR)/fft_lib/OBJECTDEFS
LIB4_OBJECTDEFS      = $(SRCDIR)/arch_lib/OBJECTDEFS
LIB5_OBJECTDEFS      = $(SRCDIR)/elpa_lib/OBJECTDEFS
LIBNVOBJECTDEFS      = $(CP2KHOME)/cuda_tools/NVOBJECTDEFS
LIBMA_OBJECTDEFS     = $(CP2KHOME)/machine/LIBMA_OBJECTDEFS
LIBCUDA_DEPENDENCIES = $(CP2KHOME)/cuda_tools/LIBCUDA_DEPENDENCIES
LIBMA_DEPENDENCIES   = $(CP2KHOME)/machine/LIBMA_DEPENDENCIES
LIB1_ARCHIVE         = $(LIBDIR)/$(VERSION)/lib$(LIB1).a
LIB2_ARCHIVE         = $(LIBDIR)/$(VERSION)/lib$(LIB2).a
LIB3_ARCHIVE         = $(LIBDIR)/$(VERSION)/lib$(LIB3).a
LIB4_ARCHIVE         = $(LIBDIR)/$(VERSION)/lib$(LIB4).a
LIB5_ARCHIVE         = $(LIBDIR)/$(VERSION)/lib$(LIB5).a
LIB_CP2K_ARCHIVE     = $(LIBDIR)/$(VERSION)/lib$(LIBCP2K).a
SRCENTRY             = $(wildcard $(SRCDIR)/.svn/entries*)
FESOBJECTDEFS        = $(TOOLSRC)/metadyn/OBJECTDEFS
DOXYGENDIR           = $(DOCDIR)/doxygen
DBCSR_TEST_PROG      = $(EXEDIR)/dbcsr_test_driver.$(VERSION)
DBCSR_PERF_PROG      = $(EXEDIR)/dbcsr_performance_driver.$(VERSION)
#PLUMED
PLUMEDDIR            = $(SRCDIR)/src-plumed
PLUMEDINC            = $(PLUMEDDIR)/plumed.inc 

REVISION := $(shell $(CP2KHOME)/tools/get_revision_number $(SRCDIR))

# SMART_MODULES prevents unnecessary recompilation of files depending
# on unchanged modules.
# Set SMART_MODULES=yes in your environment, make argument, or ARCH file.
# Needs the md5sum program somewhere in the $PATH.
# Unneeded for gfortran >= 4.5.  No effect with compilers that output a
# different .mod files even for unchanged input files.
# Assumes file case preservation.
SMART_MODULES ?= no

### Definition of the multiple targets ###
#
# Should really be
#VERSION_TARGTES= sopt sdbg popt pdbg topt hopt tdbg hdbg
VERSION_TARGETS = sopt sdbg popt pdbg ssmp psmp tdbg hdbg
#
# uses an ugly trick, these are disguised as file names, the directory (@D) part 
# is used as a version, the file (@F) part is used as the target.
#
LIB_TARGETS = $(addsuffix /lib ,$(VERSION_TARGETS)) 
ALL_TARGETS = $(addsuffix /all ,$(VERSION_TARGETS))
CLEAN_TARGETS = $(addsuffix /clean ,$(VERSION_TARGETS)) $(addsuffix /realclean ,$(VERSION_TARGETS))

#
# lists the targets that are not files
#
.PHONY : _all libs _progr _lib build clean realclean distclean $(CLEAN_TARGETS)\
         $(ALL_TARGETS) $(LIB_TARGETS) $(VERSION_TARGETS) fes dirs deptool\
         dbcsr_test dbcsr_perf mrproper plumed          

### Master rules ###
build: dirs deptool
	+$(MAKE) -C $(SRCDIR) -f $(MAKEFILE) all.dep
	+cp $(LIBCUDA_DEPENDENCIES) $(OBJDIR)/$(VERSION)/libc_cuda.dep
	+cp $(LIBMA_DEPENDENCIES) $(OBJDIR)/$(VERSION)/libc_ma.dep
	+$(MAKE) -C $(OBJDIR)/$(VERSION) -f $(MAKEFILE) $(WHAT)

fes: dirs deptool
	+$(MAKE) -C $(TOOLSRC)/metadyn/  -f $(MAKEFILE) fes.dep
	+$(MAKE) -C $(OBJDIR)/$(VERSION) -f $(MAKEFILE) HACKLIBDEP=yes VERSION=$(VERSION) $(FES) 

dirs:
	@mkdir -p $(EXEDIR)
	@mkdir -p $(LIBDIR)/$(VERSION)
	@mkdir -p $(TOOLDIR)
	@mkdir -p $(OBJDIR)/$(VERSION)
	@mkdir -p $(PRETTYOBJDIR)

realpretty: prettyclean pretty

pretty: dirs
	+$(MAKE) -C $(SRCDIR) -f $(MAKEFILE) _pretty
	+$(MAKE) -C $(SRCDIR)/lib       -f $(MAKEFILE) _pretty_lib1
	+$(MAKE) -C $(SRCDIR)/fft_lib   -f $(MAKEFILE) _pretty_lib2
	+$(MAKE) -C $(SRCDIR)/dbcsr_lib -f $(MAKEFILE) _pretty_lib3
	+$(MAKE) -C $(SRCDIR)/arch_lib  -f $(MAKEFILE) _pretty_lib4
	+$(MAKE) -C $(SRCDIR)/elpa_lib  -f $(MAKEFILE) _pretty_lib5

deptool: dirs
	+$(MAKE) LDFLAGS=$(MAKDEPF90_LDFLAGS) -C $(TOOLDIR) -f $(MAKEFILE) makedepf90

libs:
	+$(MAKE) -f $(MAKEFILE) VERSION=$(VERSION) WHAT=_lib build
all:
	+$(MAKE) -f $(MAKEFILE) VERSION=$(VERSION) WHAT=_all build
progr:
	+$(MAKE) -f $(MAKEFILE) VERSION=$(VERSION) WHAT=_progr build
cpshell:
	+$(MAKE) -f $(MAKEFILE) VERSION=$(VERSION) WHAT=_cpshell build

dbcsr_test:
	+$(MAKE) -f $(MAKEFILE) VERSION=$(VERSION) WHAT=_dbcsr_test build

dbcsr_perf:
	+$(MAKE) -f $(MAKEFILE) VERSION=$(VERSION) WHAT=_dbcsr_perf build

plumed: plumedobj plumed.dep
	+$(MAKE) -f $(MAKEFILE) VERSION=$(VERSION) WHAT=_plumed build

plumedobj: dirs
	+$(MAKE) -C $(OBJDIR)/$(VERSION)/ -f $(MAKEFILE) $(OBJ_PLUMED)

#
# on a parallel build only one task should go a build the deptool
#
$(VERSION_TARGETS): dirs deptool
	+$(MAKE) -f $(MAKEFILE) VERSION=$@ build

$(CLEAN_TARGETS):
	+$(MAKE) -f $(MAKEFILE) VERSION=$(@D) $(@F)

$(ALL_TARGETS) $(LIB_TARGETS):
	+$(MAKE) -f $(MAKEFILE) VERSION=$(@D) WHAT=_$(@F) build

#
# here we try to include all the objects that might need considering
#
include $(OBJECTDEFS)
include $(LIB1_OBJECTDEFS)
include $(LIB2_OBJECTDEFS)
include $(LIB3_OBJECTDEFS)
include $(LIB4_OBJECTDEFS)
include $(LIB5_OBJECTDEFS)
include $(FESOBJECTDEFS)
include $(MACHINEDEFS)
include $(LIBNVOBJECTDEFS)
include $(LIBMA_OBJECTDEFS)

OBJECTS = $(OBJECTS_GENERIC) $(OBJECTS_ARCHITECTURE)
FESOBJS = $(FESOBJ) $(OBJECTS_ARCHITECTURE)

# Cuda specific instructions
ifneq ($(NVCC),)
  LIBNV_ARCHIVE= $(LIBDIR)/$(VERSION)/libcp2k_cuda.a
endif

# HWTOPO
ifneq ($(HWTOPO),)
  LIBMA_ARCHIVE= $(LIBDIR)/$(VERSION)/libcp2k_ma.a
endif

ifneq ($(SMART_MODULES),no)
MD5 := $(shell which md5sum)
endif

### Logging of fortran compiler output, e.g. for examining it's warnings ###
ifneq ($(FC_SAVELOG), )
   FCLOGPIPE = &> $*.log
endif

#
#PLUMED
#
ifeq ($(PLUMED),yes)
	include $(PLUMEDINC) 
	DFLAGS += -DPLUMED_CP2K
	CPPFLAGS += -DPLUMED_CP2K
endif


# Define the whole bunch of libraries needed
ALL_LIB =  $(LIB_CP2K_ARCHIVE) $(LIB3_ARCHIVE) $(LIB2_ARCHIVE) $(LIB1_ARCHIVE) $(LIB4_ARCHIVE) $(LIB5_ARCHIVE) $(LIBMA_ARCHIVE) $(LIBNV_ARCHIVE) 
ALL_SOURCE_FILES=$(notdir $(OBJECTS:.o=.F) $(LIB1_OBJECTS:.o=.F) $(LIB2_OBJECTS:.o=.F) $(LIB4_OBJECTS:.o=.F) $(LIB3_OBJECTS:.o=.F) $(LIB5_OBJECTS:.o=.F) cp_common_uses.h cp2k.F cp2k_shell.F)

#
# some practical variables for the build
#
ifeq ($(CPPSHELL),)
CPPSHELL := -D__COMPILE_ARCH="\"$(ARCH)\""\
            -D__COMPILE_DATE="\"$(shell date)\""\
            -D__COMPILE_HOST="\"$(shell hostname)\""\
	    -D__COMPILE_REVISION="\"$(strip $(REVISION))\""
endif

ifneq ($(CPP),)
#
# always add the SRCDIR to the include path (-I here might not be portable) 
#
CPPFLAGS += $(CPPSHELL) -I$(SRCDIR)
else
FCFLAGS += $(CPPSHELL)
endif


### Slave rules ###
vpath %.F $(SRCDIRS)
vpath %.h $(SRCDIRS)
vpath %.f90 $(SRCDIRS)
vpath %.dep $(OBJDIR)/$(VERSION)
vpath %.pretty $(PRETTYOBJDIR)
vpath %.cu $(SRCDIRS)
vpath %.c $(SRCDIRS)

#
# if the modules generated are not of the lower case form (e.g. kinds.F does not lead to kinds.mod)
# use MODDEPS = no in the arch file
# MODDEPS = upper does not work because of the rule '%.mod: %.o' is incorrect (see there), but if that is
# fixed, upper should work as well.
#
ifeq ($(MODDEPS),no)
MODSTRING=
else
ifeq ($(MODDEPS),upper)
MODSTRING=-m "%M.mod"
else
MODSTRING=-m "%m.mod"
endif
endif

#
# generation of the dependencies
#
all.dep: $(ALL_SOURCE_FILES)
ifeq ($(HACKDEP),yes)
# if HACKDEP=="yes" we hack the dependencies so that only modified source files are recompiled
# this is obviously not correct (i.e. can lead to a miscompiled CP2K), 
# but if you know what you are doing (i.e. you are sure that only information private to this module will be changed) might be useful nevertheless.
	echo $(ALL_SOURCE_FILES) | awk '{for (i=1;i<=NF;i++) {obj=$$(i) ; sub(".F",".o",obj); if ($$(i)!=obj) print obj,":",$$(i) }}' > $(OBJDIR)/$(VERSION)/all.dep
else
   ifeq ($(MC),)
	$(TOOLDIR)/makedepf90 -I $(SRCDIRS) $(MODSTRING) -free $(ALL_SOURCE_FILES) > $(OBJDIR)/$(VERSION)/all.dep || ( rm -f $(OBJDIR)/$(VERSION)/all.dep  ; exit 1 )
   else
# if MC is defined, it is our 'module compiler' which generates the .mod file from the source file
# it is useful in a two-stage compile. Therefore we split the dependency in two parts the .o and the .mod.
# the awk below assumes our current rule of one mod per file
# The current module compiler is 'gfortran -fsyntax-only ' which should work fine for gfortran 4.8.0 and higher.
	$(TOOLDIR)/makedepf90 -I $(SRCDIRS) $(MODSTRING) -free $(ALL_SOURCE_FILES) | \
            awk '{deps=substr($$0,index($$0,":"),length($$0)-index($$0,":")+1); if ($$2==":") { print $$1,deps } else {print $$2,deps ; print $$1,deps,$$2 }}' > \
            $(OBJDIR)/$(VERSION)/all.dep || ( rm -f $(OBJDIR)/$(VERSION)/all.dep  ; exit 1 )
   endif
endif

# this is kind of a hack, fes depends on files in other directories, hence the -I and the -b.
fes.dep: $(FESOBJS:.o=.F) 
	$(TOOLDIR)/makedepf90 -I$(SRCDIR) -b. $(MODSTRING)  -free $^ > $(OBJDIR)/$(VERSION)/fes.dep || ( rm -f $(OBJDIR)/$(VERSION)/fes.dep  ; exit 1 )

plumed.dep: $(OBJECTS:.o=.F) $(LIB1_OBJECTS:.o=.F) $(LIB2_OBJECTS:.o=.F) $(LIB4_OBJECTS:.o=.F) $(LIB3_OBJECTS:.o=.F) $(LIB5_OBJECTS:.o=.F) cp_common_uses.h src-plumed/metadyn.h cp2k.F 

#ifeq ($(HACKDEP),yes)
#	echo $^ | awk '{for (i=1;i<=NF;i++) {obj=$$(i) ; sub(".F",".o",obj); if ($$(i)!=obj) print obj,":",$$(i) }}' > $(OBJDIR)/$(VERSION)/plumed.dep
#else
#	$(TOOLDIR)/makedepf90 $(MODSTRING)  -free $^ > $(OBJDIR)/$(VERSION)/plumed.dep || ( rm -f $(OBJDIR)/$(VERSION)/plumed.dep  ; exit 1 )
#endif
#
# and the rules doing the actual work
#
$(OBJ_PLUMED):
	$(CC) $(CPPFLAGS) -c $(PLUMEDDIR)/$(@:.o=.cpp)

_all: $(ALL_LIB) $(PROG) fes $(CP2KSHELL)
_progr: $(PROG)
_lib: $(ALL_LIB)
_cpshell: $(CP2KSHELL)
_dbcsr_test: $(DBCSR_TEST_PROG)
_dbcsr_perf: $(DBCSR_PERF_PROG)
_plumed: $(ALL_LIB) PROG-PLUMED

_pretty:$(OBJECTS:.o=.pretty)
_pretty_lib1:$(LIB1_OBJECTS:.o=.pretty)
_pretty_lib2:$(LIB2_OBJECTS:.o=.pretty)
_pretty_lib3:$(LIB3_OBJECTS:.o=.pretty)
_pretty_lib4:$(LIB4_OBJECTS:.o=.pretty)
_pretty_lib5:$(LIB5_OBJECTS:.o=.pretty)


$(LIB1_ARCHIVE): $(LIB1_OBJECTS)
	$(AR) $(LIB1_ARCHIVE) $?
ifneq ($(RANLIB),)
	$(RANLIB) $(LIB1_ARCHIVE)
endif

$(LIB2_ARCHIVE): $(LIB2_OBJECTS)
	$(AR) $(LIB2_ARCHIVE) $?
ifneq ($(RANLIB),)
	$(RANLIB) $(LIB2_ARCHIVE)
endif

$(LIB3_ARCHIVE): $(LIB3_OBJECTS)
	$(AR) $(LIB3_ARCHIVE) $?
ifneq ($(RANLIB),)
	$(RANLIB) $(LIB3_ARCHIVE)
endif

$(LIB4_ARCHIVE): $(LIB4_OBJECTS)
	$(AR) $(LIB4_ARCHIVE) $?
ifneq ($(RANLIB),)
	$(RANLIB) $(LIB4_ARCHIVE)
endif

$(LIB5_ARCHIVE): $(LIB5_OBJECTS)
	$(AR) $(LIB5_ARCHIVE) $?
ifneq ($(RANLIB),)
	$(RANLIB) $(LIB5_ARCHIVE)
endif

#
# a hack to first compile the src/lib/ stuff before files from src/
# otherwise we have missing dependencies
#
ifneq ($(HACKLIBDEP),yes)

=== tools/build_libsmm/Makefile ===
# Builds the SMM library in 5 steps:
# 1. Builds programs to test tiny MM performance.
# 2. Runs programs to test tiny MM performance.
# 3. Builds programs to test small MM performance; needs data from
#    tiny MM performance
# 4. Runs programs to test small MM performance
# 5. Builds library; needs data from small MM performance

# Recommended targets:
# do.compile.tiny
# do.bench.tiny
# do.compile.small
# do.bench.small
# do.lib.test

.PHONY: all
all: do.lib.test

.PHONY: clean
clean:
	rm -fr run_tiny* run_small* *.x *.mod *.o

include config.mk

# Some dependency relaxation
ifeq ($(LOOSE),yes)
LOOSE=|
else
LOOSE=
endif
# Some dependency relaxation
ifeq ($(VERYLOOSE),yes)
VERYLOOSE=|
else
VERYLOOSE=
endif

# Builds the rules
TINY_SET = $(foreach m,$(dims_tiny),$(foreach n,$(dims_tiny),$(foreach k,$(dims_tiny),$m_$n_$k)))

SMALL_SET = $(foreach m,$(dims_small),$(foreach n,$(dims_small),$(foreach k,$(dims_small),$m_$n_$k)))

# More variable transformations
ifeq ($(data_type),1)
    filedatatype=d
    gemm=DGEMM
    strdat=REAL(KIND=KIND(0.0D0))
endif
ifeq ($(data_type),2)
    filedatatype=s
    gemm=SGEMM
    strdat=REAL(KIND=KIND(0.0))
endif
ifeq ($(data_type),3)
    filedatatype=z
    gemm=ZGEMM
    strdat=COMPLEX(KIND=KIND(0.0D0))
endif
ifeq ($(data_type),4)
    filedatatype=c
    gemm=CGEMM
    strdat=COMPLEX(KIND=KIND(0.0))
endif

ifeq ($(transpose_flavor),1)
    trtype=nn
    ta=N
    tb=N
    decl=A(M,K), B(K,N)
    lds=LDA=M ; LDB=K
endif
ifeq ($(transpose_flavor),2)
    trtype=tn
    ta=T
    tb=N
    decl=A(K,M), B(K,N)
    lds=LDA=K ; LDB=K
endif
ifeq ($(transpose_flavor),3)
    trtype=nt
    ta=N
    tb=T
    decl=A(M,K), B(N,K)
    lds=LDA=M ; LDB=N
endif
ifeq ($(transpose_flavor),4)
    trtype=tt
    ta=T
    tb=T
    decl=A(K,M), B(N,K)
    lds=LDA=K ; LDB=N
endif

filetrans=$(filedatatype)$(trtype)



# After completion all tiny benchmarks should have been compiled.
.PHONY: do.compile.tiny
do.compile.tiny: $(patsubst %,run_tiny_%/tiny_find.x,$(TINY_SET))

# After completion all small benchmarks should have been compiled.
.PHONY: do.compile.small
do.compile.small: $(patsubst %,run_small_%/small_find.x,$(SMALL_SET))

# After completion all tiny benchmarks should have been run and the
# result file generated.
.PHONY: do.bench.tiny
do.bench.tiny: tiny_gen_optimal.out

# After completion all tiny benchmarks should have been run and the
# result file generated.
.PHONY: do.bench.small
do.bench.small: small_gen_optimal.out

# Perform library test
.PHONY: do.lib.test
do.lib.test: test_smm_$(filetrans).out



# Generate tiny source files
.PRECIOUS : run_tiny_%/tiny_find.f90
run_tiny_%/tiny_find.f90: $(LOOSE) tiny_gen.x
	mkdir -p run_tiny_$*
	./tiny_gen.x $(subst _, ,$*) $(transpose_flavor) $(data_type) > $@

# Compile and link tiny source files
.PRECIOUS : run_tiny_%/tiny_find.x
run_tiny_%/tiny_find.x: run_tiny_%/tiny_find.f90
	cd run_tiny_$* ; $(target_compile) tiny_find.f90 -o tiny_find.x.tmp && mv tiny_find.x.tmp tiny_find.x

# Benchmark tiny
# Must be ordered to come after all compilations are done so that all
# processors are devoted to running jobs.
.PRECIOUS : run_tiny_%/tiny_find.out
run_tiny_%/tiny_find.out: run_tiny_%/tiny_find.x | do.compile.tiny
	cd run_tiny_$* ; ./tiny_find.x > tiny_find.out.tmp && mv tiny_find.out.tmp tiny_find.out


# Generate small source files
.PRECIOUS : run_small_%/small_find.f90
run_small_%/small_find.f90: $(VERYLOOSE) tiny_gen_optimal.out $(LOOSE) small_gen.x
	mkdir -p run_small_$*
	./small_gen.x $(subst _, ,$*) $(transpose_flavor) $(data_type) $(SIMD_size) "tiny_gen_optimal.out" > $@

# Compile and link small source files
.PRECIOUS : run_small_%/small_find.x
run_small_%/small_find.x: run_small_%/small_find.f90
	cd run_small_$* ; $(target_compile) small_find.f90 -o small_find.x.tmp $(blas_linking) && mv small_find.x.tmp small_find.x

# Benchmark small.
# Must be ordered to come after all compilations are done so that all
# processors are devoted to running jobs.
.PRECIOUS : run_small_%/small_find.out
run_small_%/small_find.out: run_small_%/small_find.x | do.compile.small
	cd run_small_$* ; ./small_find.x > small_find.tmp && mv small_find.tmp small_find.out


# Compile the helper/generation programs

small_gen.x: small_gen.f90 mults.o multrec_gen.o
	$(host_compile) -o $@ $^

tiny_gen.x: tiny_gen.f90 mults.o
	$(host_compile) -o $@ $^

lib_gen.x: lib_gen.f90 mults.o multrec_gen.o
	$(host_compile) -o $@ $^

multrec_gen.o: multrec_gen.f90 mults.mod
	$(host_compile) -o $@ -c $<

# Collection of tiny benchmark results into a single file.
ALL_TINY_BENCH = $(patsubst %,run_tiny_%/tiny_find.out,$(TINY_SET))
tiny_gen_optimal.out: $(VERYLOOSE) $(ALL_TINY_BENCH)
	@rm -f $@
	@echo $(foreach combo,$(TINY_SET),"$(subst _, ,$(combo))" "$(shell tail -n 1 run_tiny_$(combo)/tiny_find.out) @") | sed -e 's/@ /\n/g' -e 's/@//' > $@

# Collection of small benchmark results into a single file.
ALL_SMALL_BENCH = $(patsubst %,run_small_%/small_find.out,$(SMALL_SET))
small_gen_optimal.out: $(VERYLOOSE) $(ALL_SMALL_BENCH)
	@rm -f $@
	@echo $(foreach combo,$(SMALL_SET),"$(subst _, ,$(combo))" "$(shell tail -n 1 run_small_$(combo)/small_find.out) @") | sed -e 's/@ /\n/g' -e 's/@//' > $@


# Library building

libdir: | lib

lib:
	mkdir -p lib

SMALL_OBJECTS = $(patsubst %,lib/smm_m_$(filetrans)_%.o,$(SMALL_SET))
DRIVER = smm_$(filetrans)

# SMM Library
lib/libsmm_$(filetrans).a: lib/$(DRIVER).o $(SMALL_OBJECTS)
	cd lib ; ar -r $(notdir $@) $(foreach f,$^,$(notdir $f))

# Testing program
test_smm_$(filetrans).x: test_smm_$(filetrans).f90 lib/libsmm_$(filetrans).a
	$(target_compile) -o $@ $< -Llib -lsmm_$(filetrans) $(blas_linking)

# Main library entry point
lib/$(DRIVER).o: lib/$(DRIVER).f90
	cd lib ; $(target_compile) -c $(notdir $<)

# Small MM object
.PRECIOUS: lib/smm_%.o
lib/smm_m_$(filetrans)_%.o: lib/smm_m_$(filetrans)_%.f90
	cd lib ; $(target_compile) -c $(notdir $<)

# Small MM source
.PRECIOUS: lib/smm_m_$(filetrans)_%.f90
lib/smm_m_$(filetrans)_%.f90: lib_gen.x small_gen_optimal.out | libdir
	./lib_gen.x $(subst _, ,$*) $(transpose_flavor) $(data_type) $(SIMD_size) "small_gen_optimal.out" "tiny_gen_optimal.out" > $@.tmp
	@mv $@.tmp $@


# Library test
.PRECIOUS : test_smm_$(filetrans).out
test_smm_$(filetrans).out: test_smm_$(filetrans).x
	./$< | tee $@.tmp
	@grep 'BLAS and smm yield different results' ./test_smm_${filetrans}.out &> /dev/null && ( \
	echo "Library is miscompiled ... removing lib/libsmm_$(filetrans).a" ; \
	rm -f lib/libsmm_${filetrans}.a ; exit 1) || true
	@echo "Done... check performance looking at test_smm_$(filetrans).out"
	@echo "Final library can be linked as -L$(shell pwd)/lib -lsmm_$(filetrans)"
	@mv $@.tmp $@

# Generic compilation rule for utility programs
%.o %.mod: %.f90
	$(host_compile) -c $<


# Ugly code generation

numsize  = $(shell echo $(dims_small) | awk "{print NF;}")
maxsize = $(shell echo $(dims_small) | awk "{maxs=0; for(i=1; i<=NF; i++) {maxs=(\$$i>maxs)?\$$i:maxs;}; print maxs;}")
# eles is a mapping of block sizes to sequence number.
# E.g., 1 4 -> (/0,1,0,0,1/))
eles = $(shell echo $(dims_small) | awk "{\
maxs = 0;\
for (i=1;i<=NF; i++) {maxs=(\$$i>maxs)?\$$i:maxs;};\
order = 1;\
for(i=1; i<=NF; i++) map[\$$i]=order++;\
printf \"(/0\";\
for(i=1; i<=maxs; i++) printf \",%d\", map[i];\
printf \"/)\n\";}")

lib/$(DRIVER).f90: config.in libdir
	@printf "SUBROUTINE smm_$(filetrans)(M,N,K,A,B,C)\n INTEGER :: M,N,K,LDA,LDB\n $(strdat) :: C(M,N), $(decl)\n" > $@.tmp
	printf " INTEGER, PARAMETER :: indx(0:$(maxsize))=&\n $(eles)\n" >> $@.tmp
	@printf " INTEGER :: im,in,ik,itot\n" >> $@.tmp
	@printf " $(strdat), PARAMETER :: one=1\n" >> $@.tmp
	@printf " $(lds)\n" >> $@.tmp
	@printf " IF (M<=$(maxsize)) THEN\n   im=indx(M)\n ELSE\n   im=0\n ENDIF\n" >> $@.tmp
	@printf " IF (N<=$(maxsize)) THEN\n   in=indx(N)\n ELSE\n   in=0\n ENDIF\n" >> $@.tmp
	@printf " IF (K<=$(maxsize)) THEN\n   ik=indx(K)\n ELSE\n   ik=0\n ENDIF\n" >> $@.tmp
	@printf " itot=(ik*($(numsize)+1)+in)*($(numsize)+1)+im\n" >> $@.tmp
	@printf " SELECT CASE(itot)\n" >> $@.tmp
	@echo $(dims_small) | awk "{\
		cnt=0;\
		for (myk=0;myk<=NF;myk++)\
		for (myn=0;myn<=NF;myn++)\
		for (mym=0;mym<=NF;mym++) {\
			printf \" CASE(%d)\n\",cnt++;\
			prod=myk*myn*mym;\
			if (prod==0)\
				printf \"    GOTO 999\n\";\
			else\
				printf \"    CALL smm_$(filetrans)_%d_%d_%d(A,B,C)\n\",\$$mym,\$$myn,\$$myk;\
		};\
	}" >> $@.tmp
	@printf " END SELECT\n" >> $@.tmp
	@printf " RETURN\n" >> $@.tmp
	@printf "999 CONTINUE \n CALL $(gemm)(\'%s\',\'%s\',M,N,K,one,A,LDA,B,LDB,one,C,M)\n" $(ta) $(tb) >> $@.tmp
	printf "END SUBROUTINE smm_$(filetrans)\n" >> $@.tmp
	mv $@.tmp $@

#Testing program
test_smm_$(filetrans).f90: config.in
	printf "MODULE WTF\n" > $@.tmp
	@printf "  INTERFACE MYRAND\n" >> $@.tmp
	@printf "    MODULE PROCEDURE SMYRAND, DMYRAND, CMYRAND, ZMYRAND\n" >> $@.tmp
	@printf "  END INTERFACE\n" >> $@.tmp
	@printf "CONTAINS\n" >> $@.tmp
	@printf "  SUBROUTINE DMYRAND(A)\n" >> $@.tmp
	@printf "    REAL(KIND=KIND(0.0D0)), DIMENSION(:,:) :: A\n" >> $@.tmp
	@printf "    REAL(KIND=KIND(0.0)), DIMENSION(SIZE(A,1),SIZE(A,2)) :: Aeq\n" >> $@.tmp
	@printf "    CALL RANDOM_NUMBER(Aeq)\n" >> $@.tmp
	@printf "    A=Aeq\n" >> $@.tmp
	@printf "  END SUBROUTINE\n" >> $@.tmp
	@printf "  SUBROUTINE SMYRAND(A)\n" >> $@.tmp
	@printf "    REAL(KIND=KIND(0.0)), DIMENSION(:,:) :: A\n" >> $@.tmp
	@printf "    REAL(KIND=KIND(0.0)), DIMENSION(SIZE(A,1),SIZE(A,2)) :: Aeq\n" >> $@.tmp
	@printf "    CALL RANDOM_NUMBER(Aeq)\n" >> $@.tmp
	@printf "    A=Aeq\n" >> $@.tmp
	@printf "  END SUBROUTINE\n" >> $@.tmp
	@printf "  SUBROUTINE CMYRAND(A)\n" >> $@.tmp
	@printf "    COMPLEX(KIND=KIND(0.0)), DIMENSION(:,:) :: A\n" >> $@.tmp
	@printf "    REAL(KIND=KIND(0.0)), DIMENSION(SIZE(A,1),SIZE(A,2)) :: Aeq,Beq\n" >> $@.tmp
	@printf "    CALL RANDOM_NUMBER(Aeq)\n" >> $@.tmp
	@printf "    CALL RANDOM_NUMBER(Beq)\n" >> $@.tmp
	@printf "    A=CMPLX(Aeq,Beq,KIND=KIND(0.0))\n" >> $@.tmp
	@printf "  END SUBROUTINE\n" >> $@.tmp
	@printf "  SUBROUTINE ZMYRAND(A)\n" >> $@.tmp
	@printf "    COMPLEX(KIND=KIND(0.0D0)), DIMENSION(:,:) :: A\n" >> $@.tmp
	@printf "    REAL(KIND=KIND(0.0)), DIMENSION(SIZE(A,1),SIZE(A,2)) :: Aeq,Beq\n" >> $@.tmp
	@printf "    CALL RANDOM_NUMBER(Aeq)\n" >> $@.tmp
	@printf "    CALL RANDOM_NUMBER(Beq)\n" >> $@.tmp
	@printf "    A=CMPLX(Aeq,Beq,KIND=KIND(0.0D0))\n" >> $@.tmp
	@printf "  END SUBROUTINE\n" >> $@.tmp
	@printf "END MODULE\n" >> $@.tmp
	@printf "SUBROUTINE testit(M,N,K)\n" >> $@.tmp
	@printf "  USE WTF\n" >> $@.tmp
	@printf "  IMPLICIT NONE\n" >> $@.tmp
	@printf "  INTEGER :: M,N,K\n" >> $@.tmp
	@printf "\n" >> $@.tmp
	@printf "  $(strdat) :: C1(M,N), C2(M,N)\n" >> $@.tmp
	@printf "  $(strdat) :: $(decl)\n" >> $@.tmp
	@printf "  $(strdat), PARAMETER :: one=1\n" >> $@.tmp
	@printf "  INTEGER :: i,LDA,LDB\n" >> $@.tmp
	@printf "\n" >> $@.tmp
	@printf "  REAL(KIND=KIND(0.0D0)) :: flops,gflop\n" >> $@.tmp
	@printf "  REAL :: t1,t2,t3,t4\n" >> $@.tmp
	@printf "  INTEGER :: Niter\n" >> $@.tmp
	@printf "\n" >> $@.tmp
	@printf "  flops=2*REAL(M,KIND=KIND(0.0D0))*N*K\n" >> $@.tmp
	@printf "  gflop=1000.0D0*1000.0D0*1000.0D0\n" >> $@.tmp
	@printf "  ! assume we would like to do 5 Gflop for testing a subroutine\n" >> $@.tmp
	@printf "  Niter=MAX(1,CEILING(MIN(10000000.0D0,5*gflop/flops)))\n" >> $@.tmp
	@printf "  $(lds)\n" >> $@.tmp
	@printf "\n" >> $@.tmp
	@printf "  DO i=1,10\n" >> $@.tmp
	@printf "     CALL MYRAND(A)\n" >> $@.tmp
	@printf "     CALL MYRAND(B)\n" >> $@.tmp
	@printf "     CALL MYRAND(C1)\n" >> $@.tmp
	@printf "     C2=C1\n" >> $@.tmp
	@printf "\n" >> $@.tmp
	@printf "     CALL $(gemm)(\"$(ta)\",\"$(tb)\",M,N,K,one,A,LDA,B,LDB,one,C1,M) \n" >> $@.tmp
	@printf "     CALL smm_$(filetrans)(M,N,K,A,B,C2)\n" >> $@.tmp
	@printf "\n" >> $@.tmp
	@printf "     IF (MAXVAL(ABS(C2-C1))>100*EPSILON(REAL(1.0,KIND=KIND(A(1,1))))) THEN\n" >> $@.tmp
	@printf "        write(6,*) \"Matrix size\",M,N,K\n" >> $@.tmp
	@printf "        write(6,*) \"A=\",A\n" >> $@.tmp

=== tools/autotune_grid/xyz_to_vab/Makefile ===



include ../config.mk

PYTHON=python

default: xyz_to_vab.o

lib_kinds.mod:
	$(FC_comp) $(FCFLAGS) -c lib_kinds.F

xyz_to_vab.o: lib_kinds.mod
	${PYTHON} template_parser.py xyz_to_vab_optimised.mod.template xyz_to_vab_optimised.F
	$(FC_comp) $(FCFLAGS)  -c xyz_to_vab_optimised.F



clean: 
	rm xyz_to_vab_optimised.mod xyz_to_vab_optimised.o lib_kinds.o lib_kinds.mod

=== debian/changelog ===
cp2k (2.4.0-2) unstable; urgency=low

  * debian/patches/makeflags.patch: Added -lmpi to LIBS variable, fixes FTBFS
    on MPICH architectures.

 -- Michael Banck <mbanck@debian.org>  Fri, 04 Oct 2013 12:21:18 +0200

cp2k (2.4.0-1) unstable; urgency=low

  * New upstream release. 
    + Fixes AMBER torsion energy (Closes: #706608)
  * New features include:
    + Resolution-of-the-identity RI-MP2 and RI-RPA energies
    + Non-local vDW corrections for XC functionals including B88-vDW, PBE-vDW
      and B97X-D
    + Various new XC functionals via LibXC support
    + Support for non-linear core corrected (NLCC) pseudopotentials
    + Adaptive QM/MM
    + Additional linear scaling algorithms and properties
    + ELPA parallel eigensolver support
    + Possibility of using image charges
    + Integrated basis set optimisation
    + PLUMED support

  [ Daniel Leidert ]
  * debian/control (DM-Upload-Allowed): Dropped.
    (Standards-Version): Bumped to 3.9.4.
    (Vcs-Browser, Vcs-Svn): Fixed vcs-field-not-canonical.
  * debian/watch: Fixed.
  * debian/patches/fftw3_unaligned.patch: Dropped (applied upstream).
  * debian/patches/dftb_atom_input_dependence.patch: Ditto.
  * debian/patches/series: Adjusted.

  [ Michael Banck ]
  * debian/rules (override_dh_auto_test): Update OMPI_MCA environment variable
    to orte_rsh_agent as the original plm_rsh_agent variable is deprecated.
  * debian/control (Build-Depends): Added libxc-dev.
  * debian/patches/makeflags.patch: Added support for libxc.
  * debian/rules (override_dh_auto_test): Added QS/regtest-libxc to
    testsuite directories.
  * debian/cp2k-data.install: Install all data files from tests/QS directory.
  * debian/patches/basis_set_error_631++Gxx.patch: Dropped (applied upstream).
  * debian/patches/gcc-4.8_fixes.patch: Likewise.
  * debian/cp2k.install: Moved documentation to ...
  * debian/cp2k-data.install: ... here.

 -- Michael Banck <mbanck@debian.org>  Mon, 23 Sep 2013 11:39:02 +0200

=== debian/control ===
Source: cp2k
Section: science
Priority: optional
Maintainer: Debichem Team <debichem-devel@lists.alioth.debian.org>
Uploaders: Michael Banck <mbanck@debian.org>
Build-Depends: bc,
               bison,
               debhelper (>= 7.0.50~),
               default-jre-headless,
               flex,
               gfortran,
               libblas-dev,
               libfftw3-dev,
               libint-dev,
               liblapack-dev,
               libsaxonb-java,
               libscalapack-mpi-dev,
               libxc-dev,
               mpi-default-dev
Standards-Version: 3.9.4
Homepage: http://www.cp2k.org
Vcs-Browser: http://anonscm.debian.org/viewvc/debichem/unstable/cp2k/
Vcs-Svn: svn://anonscm.debian.org/debichem/unstable/cp2k/

Package: cp2k
Architecture: any
Depends: cp2k-data (= ${source:Version}), ${misc:Depends}, ${shlibs:Depends}
Description: Ab Initio Molecular Dynamics
 CP2K is a program to perform simulations of solid state, liquid, molecular and
 biological systems. It is especially aimed at massively parallel and linear
 scaling electronic structure methods and state-of-the-art ab-inito molecular
 dynamics (AIMD) simulations. Features include:
 .
 Ab-initio Electronic Structure Theory Methods using the QUICKSTEP module:
 .
  * Density-Functional Theory (DFT) energies and forces with various Exchange-
    Correlation (XC) functionals
  * Hartree-Fock (HF) energies and forces
  * Moeller-Plesset 2nd order perturbation theory (MP2) energies
  * Gas phase or Periodic boundary conditions (PBC)
  * Basis sets include various standard Gaussian-Type Orbitals (GTOs), Pseudo-
    potential plane-waves (PW), augmented plane waves (APW) and a mixed
    Gaussian and (augmented) plane wave approach (GPW / GAPW)
  * Pseudo-Potentials (PP) including the norm-conserving, seperable
    Goedecker-Teter-Hutter (GTH) PP
  * Local Density Approximation (LDA) XC functionals including SVWN3, SVWN5,
    PW92 and PADE
  * Gradient-corrected (GGA) XC functionals including BLYP, BP86, PW91, PBE and
    HCTH120 as well as the meta-GGA XC functional TPSS
  * Hybrid XC functionals with exact Hartree-Fock Exchange (HFX) including
    B3LYP, PBE0 and MCY3
  * Double-hybrid XC functionals including B2PLYP and B2GPPLYP
  * Dispersion corrections via DFT-D2 and DFT-D3 pair-potential models
  * Density-Fitting for DFT via Bloechl or Density Derived Atomic Point Charges
    (DDAPC) charges and for HFX via Auxiliary Density Matrix Methods (ADMM)
  * Sparse matrix and prescreening techniques for linear-scaling Kohn-Sham (KS)
    matrix computation
  * Orbital Transformation (OT) or Direct Inversion of the iterative subspace
    (DIIS) self-consistent field (SCF) minimizer
  * Excited states via time-dependent DFT (TDDFT)
 .
 Ab-initio Molecular Dynamics:
 .
  * Born-Oppenheimer Molecular Dynamics (BOMD)
  * Ehrenfest Molecular Dynamics (EMD)
  * PS extrapolation of initial wavefunction
  * Time-reversible Always Stable Predictor-Corrector (ASPC) integrator
  * Approximate Car-Parinello like Langevin Born-Oppenheimer Molecular Dynamics
 .
 Mixed quantum-classical (QM/MM) simulations:
 .
  * Real-space multigrid approach for the evaluation of the Coulomb
    interactions between the QM and the MM part
  * Linear-scaling electrostatic coupling treating of periodic boundary
    conditions
 .
 Further Features include:
 .
  * Single-point energies, geometry optimizations and frequency calculations
  * Several nudged-elastic band (NEB) algorithms (B-NEB, IT-NEB, CI-NEB, D-NEB)
    for minimum energy path (MEP) calculations
  * Semi-Empirical calculations including the AM1, RM1, PM3, MNDO, MNDO-d, PNNL
    and PM6 parametrizations, density-functional tight-binding (DFTB) and
    self-consistent-polarization tight-binding (SCP-TB), with or without
    periodic boundary conditions
  * Classical Molecular Dynamics (MD) simulations in microcanonical ensemble
    (NVE) or canonical ensmble (NVT) with Nose-Hover and canonical sampling
    through velocity rescaling (CSVR) thermostats
  * Metadynamics including well-tempered Metadynamics for Free Energy
    calculations
  * Classical Force-Field (MM) simulations
  * Monte-Carlo (MC) KS-DFT simulations
  * Static (e.g. spectra) and dynamical (e.g. diffusion) properties
 .
 CP2K does not implement Car-Parinello Molecular Dynamics (CPMD).

Package: cp2k-data
Architecture: all
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Ab Initio Molecular Dynamics (data files)
 CP2K is a program to perform simulations of solid state, liquid, molecular and
 biological systems. It is especially aimed at massively parallel and linear
 scaling electronic structure methods and state-of-the-art ab-inito molecular
 dynamics (AIMD) simulations.
 .
 This package contains basis sets, pseudo-potentials and force-field parameters.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

include /usr/share/mpi-default-dev/debian_defaults

DEB_BUILD_ARCH=$(shell dpkg-architecture -qDEB_BUILD_ARCH)

ifeq ($(DEB_BUILD_ARCH), i386)
    export FFTW3_ALIGN=-D__FFTW3_UNALIGNED
else
    export FFTW3_ALIGN=
endif

export LIB_SCALAPACK=-lscalapack-$(ARCH_DEFAULT_MPI_IMPL)
export LIB_BLACS=-lblacsCinit-$(ARCH_DEFAULT_MPI_IMPL) -lblacs-$(ARCH_DEFAULT_MPI_IMPL)
export OMPI_MCA_orte_rsh_agent=/bin/false

PLATFORM=Linux
ARCH=`uname -m`
FORT_C_NAME=gfortran

%:
	dh $@ 

override_dh_auto_clean:
	(cd arch; ln -fs $(PLATFORM)-generic-$(FORT_C_NAME).popt $(PLATFORM)-$(ARCH)-$(FORT_C_NAME).popt)
	(cd makefiles; $(MAKE) ARCH=$(PLATFORM)-$(ARCH)-$(FORT_C_NAME) VERSION=popt distclean)
	(cd web/manual; rm -rf CP2K_INPUT; rm -f *.html *.xml)
	rm -f arch/$(PLATFORM)-$(ARCH)-$(FORT_C_NAME).*
	rm -rf LAST* TEST*
	dh_auto_clean

override_dh_auto_build:
	(cd arch; ln -fs $(PLATFORM)-generic-$(FORT_C_NAME).popt $(PLATFORM)-$(ARCH)-$(FORT_C_NAME).popt)
	(cd makefiles; $(MAKE) ARCH=$(PLATFORM)-$(ARCH)-$(FORT_C_NAME) VERSION=popt all)
	(cd web/manual; $(CURDIR)/exe/*/cp2k.popt --xml)
	(cd web/manual; saxonb-xslt -o index.html -ext:on cp2k_input.xml cp2k_input.xsl)
	(cd web/manual; saxonb-xslt -o index_javascript.html -ext:on cp2k_input.xml cp2k_input_javascript.xsl)

ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
override_dh_auto_test:
	ln -nfs testresults LAST-$(PLATFORM)-$(ARCH)-$(FORT_C_NAME)-popt
	-(cd tools; ARCH=$(PLATFORM)-$(ARCH)-$(FORT_C_NAME) ./do_regtest -quick \
		-config ../debian/regtest.config                                \
		-restrictdir ATOM/regtest-2                                     \
		-restrictdir DFTB/regtest-nonscc                                \
		-restrictdir FE/regtest-2                                       \
		-restrictdir Fist/regtest-2                                     \
		-restrictdir MC/regtest                                         \
		-restrictdir NEB/regtest-3                                      \
		-restrictdir QMMM/QS/regtest-2-erf                              \
		-restrictdir QMMM/SE/regtest_2                                  \
		-restrictdir QS/regtest-gapw-2                                  \
		-restrictdir QS/regtest-gpw-1                                   \
		-restrictdir QS/regtest-hfx-periodic                            \
		-restrictdir QS/regtest-hfx-stress                              \
		-restrictdir QS/regtest-linearscaling                           \
		-restrictdir QS/regtest-nmr-2                                   \
		-restrictdir QS/regtest-libxc                                   \
		-restrictdir QS/regtest-ot-refine                               \
		-restrictdir SE/regtest-4 )
endif
